/*
 * Copyright (C) 2012 - 2016 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// MultipleUifsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MultipleUifs.h"
#include "MultipleUifsDlg.h"
#include "MSP430.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultipleUifsDlg dialog

CMultipleUifsDlg::CMultipleUifsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMultipleUifsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMultipleUifsDlg)
	m_iJtagIf = -1;
	m_strSelectionStatus = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMultipleUifsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMultipleUifsDlg)
	DDX_Control(pDX, IDC_LIST_JTAGIF_PORT, m_ctrlJtagIfPort);
	DDX_Radio(pDX, IDC_RADIO_JTAGIF, m_iJtagIf);
	DDX_Text(pDX, IDC_STATIC_SELECTION, m_strSelectionStatus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMultipleUifsDlg, CDialog)
	//{{AFX_MSG_MAP(CMultipleUifsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RADIO_JTAGIF, OnRadioJtagif)
	ON_BN_CLICKED(IDC_RADIO_JTAGIF2, OnRadioJtagif)
	ON_LBN_SELCHANGE(IDC_LIST_JTAGIF_PORT, OnSelchangeListJtagifPort)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultipleUifsDlg message handlers

BOOL CMultipleUifsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

    m_iJtagIf = 0;                              // Init radio buttons
    m_bIs430DllInitialized = FALSE;               //

    CMultipleUifsDlg::JtagIfPortList(m_iJtagIf);

    m_strSelectionStatus.Format("none");

    UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMultipleUifsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMultipleUifsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMultipleUifsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//-----------------------------------------------------------------------------
// Additional Member Functions

//-----------------------------------------------------------------------------
// CMultipleUifsDlg::OnRadioJtagif
// Desc: Message handler when one of the radio buttons is beeing clicked.
void CMultipleUifsDlg::OnRadioJtagif() 
{
    UpdateData(TRUE);
	CMultipleUifsDlg::JtagIfPortList(m_iJtagIf);
}

//-----------------------------------------------------------------------------
// CMultipleUifsDlg::JtagIfPortList()
// Desc: Fills the ListBox with available ports depending on the selected
//       JTAG interface (radio button).
void CMultipleUifsDlg::JtagIfPortList(int JtagIf)
{
    // Call MSP430_Close() if necessary
    CMultipleUifsDlg::CloseMSP430Dll();
    // Delete ListBox content
    m_ctrlJtagIfPort.ResetContent();
    // Initialize status string member variable
    m_strSelectionStatus = "none";

    // Fill ListBox according to selected interface (radio button)
    switch(JtagIf)
    {
        case 0: // MSP-FET430PIF
            m_ctrlJtagIfPort.AddString("LPT1");
            m_ctrlJtagIfPort.AddString("LPT2");
            m_ctrlJtagIfPort.AddString("LPT3");
            break;
        case 1: // MSP-FET430UIF
            {
                STATUS_T RetState = STATUS_ERROR;
                int32_t  lNumber  = 0;
                int32_t  lStatus  = 0;

                // Retrieve number of connected USB FETs
                RetState = MSP430_GetNumberOfUsbIfs(&lNumber);

                // Retrieve according COM port names
                for(LONG i = 0; i < lNumber; i++)
                {
                    RetState = MSP430_GetNameOfUsbIf(i, (char**)&m_JtagIfComPorts[i], &lStatus);

                    if(RetState == STATUS_OK)
                    {
                        CString tmpListEntry = m_JtagIfComPorts[i];

                        // Show status of USB FET, whether it is ready to be selected
                        // or already in use by another debugger instance.
                        if(lStatus == ENABLE)
                        {
                            tmpListEntry += " (n.a.)";
                        }
                        // Add string to LixBox
                        m_ctrlJtagIfPort.AddString(tmpListEntry);
                    }
                }
            }
            break;
        default:
            break;
    }

    UpdateData(FALSE); // initialize data in a dialog box
}

//-----------------------------------------------------------------------------
// CMultipleUifsDlg::OnSelchangeListJtagifPort()
// Desc: Makes according actions when a port gets selected in the ListBox by
//       the user. The current selection status is displayed on the GUI.
void CMultipleUifsDlg::OnSelchangeListJtagifPort() 
{
	int         iSelection;
    STATUS_T    RetState             = STATUS_ERROR;
    int32_t     version              = 0;
    CString     CurrentSelection     = "none";

    UpdateData(TRUE); // retrieve and validate dialog data

    iSelection = m_ctrlJtagIfPort.GetCurSel(); // get selected port (list item)

    switch(m_iJtagIf)
    {
        case 0: // MSP-FET430PIF
            m_ctrlJtagIfPort.GetText(iSelection, CurrentSelection);
            CurrentSelection = "MSP-FET430PIF on " + CurrentSelection;
            break;
        case 1: // MSP-FET430UIF
            CMultipleUifsDlg::CloseMSP430Dll();

            // Initialize the selected interface by passing the according
            // COM port name to MSP430_Initialize()
            RetState = MSP430_Initialize(m_JtagIfComPorts[iSelection], &version);

            // Dispaly status of initialization on the GUI
            if(RetState == STATUS_OK)
            {
                CurrentSelection.Format(m_JtagIfComPorts[iSelection]);
                CurrentSelection = "MSP-FET430UIF on " + CurrentSelection + " (Mode LED on)";
            }
            else
            {
                // Display MSP430.DLL error strings in case of failures
                CurrentSelection.Format(MSP430_Error_String(MSP430_Error_Number()));
            }

            // Store initialization status in member variable
            m_bIs430DllInitialized = TRUE;
            break;
        default: break;
    }

    // Update status string member variable
    m_strSelectionStatus = CurrentSelection;

    UpdateData(FALSE); // initialize data in a dialog box
}

//-----------------------------------------------------------------------------
// CMultipleUifsDlg::CloseMSP430Dll()
// Desc: Takes care about calling MSP430_Close() in case MSP430_Initialize()
//       has been called prior. Status of DLL initialization is stored in a
//       global member variable.
void CMultipleUifsDlg::CloseMSP430Dll()
{
    if(m_bIs430DllInitialized)
    {
        MSP430_Close(TRUE);
        m_bIs430DllInitialized = FALSE;
    }
}
